<?php
//require_once('stripe\stripe-php\init.php');
require('phpmailer/phpmailer/src/sendMail.php');
require('duda_api.php');
require('stripe_api.php');

//Working
$payload = @file_get_contents("php://input");
$data = json_decode($payload);

$account_name = $data->email;
$first_name = $data->first_name;
$last_name = $data->last_name;
$template_id = $data->template_id;
$plan_id = $data->plan_id;

//DIY Process
//Create Duda Account - Create Site - Reset Password - Stats Email - Create Customer - Create Subscription - Grant Access - Send Email Notification - Add to Mailout

if(isset($account_name)){
	//Proceed to Create Account
	$create_Account_Status = create_Account($account_name,$first_name,$last_name);

	if($create_Account_Status['response_code'] == 204){
		//Proceed to Create Site {"response_code"=>200,"site_name"=>040c80da}*/
 		$create_Site_Status = create_Site($template_id);

		 if($create_Site_Status['response_code'] == 200){

			/*Proceed to Reset Password {"response_code"=>200,"reset_url"=>"link"}*/
			$reset_Password_Status = reset_Password($account_name);

			if($reset_Password_Status['response_code'] == 200){
				
				/*Proceed to Stats Email {"response_code"=>200}*/
				$stats_Email_Status = stats_Email($account_name,$create_Site_Status['site_name']);

				if($stats_Email_Status['response_code'] == 204){
					
					/*Proceed to Grant Access {"response_code"=>204}*/
					$grant_Access_Status = grant_Access($account_name,$create_Site_Status['site_name'],$permisions);

					if($grant_Access_Status['response_code'] == 204){
						

						//Main Settings for Create Stripe Account/Customer
						$create_account_setting = array(
						    "id" =>  $create_Site_Status['site_name'],
						    "source" => $data->token, // obtained with Stripe.js
						    "email" => $account_name,
						    "description" => 'DIY - '.$plan_id,
						    "metadata" => [
						        "ACCOUNT DETAILS" => '#################################',
						        "Account Name" => $account_name,
						        "Email Address" => $account_name,
						        "Site Name" => $create_Site_Status['site_name'],
						        "STRIPE DETAILS" => '#################################',
						        "Stripe First Name" => $first_name,
						        "Stripe Last Name" => $last_name,
						        "Stripe Email" => $account_name,
						    ]    
						);

						$customerID = create_customer($create_account_setting);//cus_FLbWyJSrrtJwTS

						$date = date('Y/m/d H:i:s');
						$newdate = date('Y/m/d H:i:s', strtotime($date.' + 14 days'));
						$trial_end = strtotime($newdate);

						//Main Settings for Create Subscription
						$subscription_settings = array(
							"customer" => $customerID,
							"items" => [ ["plan" => $plan_id] ],
							"trial_end" => $trial_end
						);

						// Check if coupon is set
						if(isset($data->couponID)){
							$subscription_settings['coupon'] = $data->couponID;
						}

						$subscription_Status = create_subscription($subscription_settings);

						if($subscription_Status == 'active' || $subscription_Status == 'trialing'){

							$retArr = [
								"status" => true,
								"account_name"=>$account_name,
								"first_name"=>$first_name,
								"last_name"=>$last_name,
								"site_name"=>$create_Site_Status['site_name'],
								"reset_url"=>$reset_Password_Status['reset_url'],
								"grant_access"=>$grant_Access_Status['response_code']
							];

							$sendReset_Password_Status = sendReset_Password($retArr);

							if($sendReset_Password_Status == 'Email Sent'){

								//Notif Sent
								$sendNotif_Admin_Status = sendNotif_Admin($retArr);
																
								if($sendNotif_Admin_Status == 'Notif Sent'){
									
									print_r(json_encode($retArr));
									
								}else{
									error_Handler('Sending Notif','SendingNotifFailed',$sendNotif_Admin_Status,$account_name,$first_name);	
								}

							}
						}
					}
				}else{
					//[Current Ruqest, Error Code, Error Message, Account Name, First Name]
					/*{"error_code": "Foo","message": "Bar"}*/
					error_Handler('Requesting Stats Email',$stats_Email_Status['error_code'],$stats_Email_Status['message'],$account_name,$first_name);	
				}

			}else{
				//[Current Ruqest, Error Code, Error Message, Account Name, First Name]
				/*{"error_code": "ResourceNotExist","message": "Account john_doe@sample.co doesn't exist."}*/
				error_Handler('Resetting Password',$reset_Password_Status['error_code'],$reset_Password_Status['message'],$account_name,$first_name);
			}


		 }else{
			//Delete Account after Failed Site Creation
			$delete_Acccount_Status = delete_Account($account_name);//204

			if($delete_Acccount_Status['response_code'] == 204){
				//[Current Ruqest, Error Code, Error Message, Account Name, First Name]
				/*{"error_code": "InvalidInput","message": "'template_id' does not exist"}*/
				error_Handler('Creating Site',$create_Site_Status['error_code'],$create_Site_Status['message'],$account_name,$first_name);
			}
		 }

	}else{
		//[Current Ruqest, Error Code, Error Message, Account Name, First Name]
		//$create_Site_Status = {"error_code": "ResourceAlreadyExist","message": "Account 'john_doe@sample.co' already exists"}*/
		error_Handler('Creating Account',$create_Account_Status['error_code'],$create_Account_Status['message'],$account_name,$first_name);
	}

}else{
	//[Current Ruqest, Error Code, Error Message, Account Name, First Name]
	error_Handler('Checking Field isset','AccountNameIsNotSet','Account Name is Empty',$account_name,$first_name);
}


//Error Handler
function error_Handler($current_request,$error_code,$error_message,$account_name,$first_name){
	//[Current Ruqest, Error Code, Error Message, Account Name, First Name]
	$error = ["request"=>$current_request,"code"=>$error_code,"message"=>$error_message,"account_name"=>$account_name,"first_name"=>$first_name];
	//Send Error to Email
	//$error_Status = sendError_Report($error);//Error Sent

	if($error_Status == 'Error Sent'){

		print_r(json_encode($error));
	
	}
}
?>