<?php
require('diy_init.php');

/* CHECK ACCOUNT - CREATE ACCOUNT - CREATE SITE - RESET PASSWORD - STATS EMAIL - GRANT ACCESS - GENERATE SSO */


//Create Account (/accounts/{account_name})
function create_Account($account_name,$first_name,$last_name){
	
	$data = '{
		"account_name":"'.$account_name.'",
		"first_name":"'.$first_name.'",
		"last_name":"'.$last_name.'",
		"email":"'.$account_name.'",
		"lang": "en",
		"account_type": "CUSTOMER"
	}';
	
	$curl = curl_init();
	curl_setopt_array($curl, array(
		CURLOPT_URL => duda_endpoint."/accounts/create",
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_ENCODING => "",	
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 30,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => "POST",
		CURLOPT_POSTFIELDS => $data,
		CURLOPT_HTTPHEADER => array(
			"Authorization: Basic ".API_KEY."",
		    "Content-Type: application/json",
		    "cache-control: no-cache"
			)
		)
	);
	//Initiate cURL
	$response = curl_exec($curl);//204
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 204) {
			$retArr = ["response_code"=>$responseCode];
			//{"response_code"=>204,"account_name"=>john_doe@sample.co}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceAlreadyExist","message": "Account 'john_doe@sample.co' already exists"}*/
			return $retArr;
		}
	}
}//create_Account

//Create Site (/sites/multiscreen/create)
function create_Site($template_id){
	
	$data = '{"template_id":"'.$template_id.'"}';
	
	$curl = curl_init();

	curl_setopt_array($curl, array(
	  CURLOPT_URL => duda_endpoint."/sites/multiscreen/create",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 30,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "POST",
	  CURLOPT_POSTFIELDS => $data,
	  CURLOPT_HTTPHEADER => array(
	    "Authorization: Basic ".API_KEY."",
	    "Content-Type: application/json",
	    "cache-control: no-cache"
	  )
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//{"template_id": 1000772}
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 200) {
			$output = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"site_name"=>$output->site_name];
			//{"response_code"=>200,"site_name"=>"040c80da"}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "InvalidInput","message": "'template_id' does not exist"}*/
			return $retArr;
		}
	}	
}//create_Site

//Get Reset Password Link (/accounts/reset-password/{account_name})
function reset_Password($account_name){
	
	$curl = curl_init();

	curl_setopt_array($curl, array(
	  CURLOPT_URL => duda_endpoint."/accounts/reset-password/".$account_name,
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 30,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "POST",
	  CURLOPT_HTTPHEADER => array(
	    "Authorization: Basic ".API_KEY."",
	    "cache-control: no-cache"
	  ),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//200
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 200) {
			$output = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"reset_url"=>$output->reset_url];
			//{"response_code"=>200,"reset_url"=>"http://example.mobilewebsiteserver.com/login/resetpwd?uuid=e4ec7b6f-b77f-47de-aedf-d2383ccb5de2"}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceNotExist","message": "Account john_doe@sample.co doesn't exist."}*/
			return $retArr;
		}
	}
}//reset_Password

//Get Stats Email /accounts/{account_name}/sites/{site_name}/stats-email
function stats_Email($account_name,$site_name){
	
	$data = '{"frequency":"MONTHLY"}';
	
	$curl = curl_init();
	
	curl_setopt_array($curl, array(
	  CURLOPT_URL => duda_endpoint."/accounts/".$account_name."/sites/".$site_name."/stats-email",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 30,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "POST",
	  CURLOPT_POSTFIELDS => $data,
	  CURLOPT_HTTPHEADER => array(
	    "Authorization: Basic ".API_KEY."",
	    "Content-Type: application/json",
	    "cache-control: no-cache"
	  ),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//204
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	
	if ($err) {
	  echo "cURL Error #:" . $err;
	} else {
		
	  if($responseCode == 204){
	  	$retArr = ["response_code"=>$responseCode];
		//{"response_code"=>204}
		return $retArr;
	  }else{
	  	$error = json_decode($response);
	  	$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
		/*{"error_code": "foo","message": "bar"}*/
		return $retArr;
	  }
	  
	}	
}//stats_Email

//Grant Access (/accounts/{account_name}/sites/{site_name}/permissions)
function grant_Access($account_name,$site_name,$permissions){
	
	$data = permissions;
	if(isset($permissions)){ $data = $permissions; }
	
	$curl = curl_init();
	
	curl_setopt_array($curl, array(
		CURLOPT_URL => duda_endpoint."/accounts/".$account_name."/sites/".$site_name."/permissions",
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_ENCODING => "",
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 30, 
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => "POST",
		CURLOPT_POSTFIELDS => $data,
		CURLOPT_HTTPHEADER => array(
			"Authorization: Basic ".API_KEY."",
			"Content-Type: application/json",
			"Postman-Token: 6ccf911d-8969-4167-8d37-5bd36b2f7148",
			"cache-control: no-cache"
		),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//204
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 204) {
			$retArr = ["response_code"=>$responseCode];
			//{"response_code"=>204}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceNotExist","message": "Site with alias '861470fb' doesn't exist"}*/
			return $retArr;
		}
	}
}//grant_Access

//Generate SSO Link (/accounts/sso/{account_name}/link?target=EDITOR&site_name=h5de912a)
function generate_SSO($account_name,$site_name) {
	$curl = curl_init();

	curl_setopt_array($curl, array(
	  CURLOPT_URL => duda_endpoint."/accounts/sso/".$account_name."/link?target=EDITOR&site_name=".$site_name."",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 30,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "GET",
	  CURLOPT_HTTPHEADER => array(
	    "Authorization: Basic ".API_KEY."",
	    "cache-control: no-cache"
	  ),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//200
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 200) {
			$output = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"sso_link"=>$output->url];
			//{"response_code"=>204,"sso_link"=>"http://trilogy.editor-sandbox.multiscreensite.com/home/ed/site/eeb4621d7dab47cba2474bd7fcbd124c?dm_sso=2!eyJ2ZXJzaW9uIjoyLCJyZXFVdWlkIjoiNzk1OGIyYWI4ZTNmNGFlNjlhMGZhZDIwMDRjZTMzODUiLCJjbGllbnRBZGRyZXNzIjpudWxsfQ"}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceNotExist","message": "Account lingping@thecamel.co doesn't exist."}*/
			return $retArr;
		}
	}
    
}//generate_SSO

/* PUBLISH - UNPUBLISHED - REMOVE ACCESS - DELETE ACCOUNT - DELETE SITE */

//Publish Site (/sites/multiscreen/publish/{site_name})
function publish_Site($site_name){
	
	$curl = curl_init();
	
	curl_setopt_array($curl, array(
		CURLOPT_URL => duda_endpoint."/sites/multiscreen/publish/".$site_name."?test=true",
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 30,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => "POST",
		CURLOPT_HTTPHEADER => array(
			"Authorization: Basic ".API_KEY."",
			"Content-Type: application/json",
			"cache-control: no-cache"
		),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//204
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 204) {
			$retArr = ["response_code"=>$responseCode];
			//{"response_code"=>204}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceNotExist","message": "Site with alias '861470fb' doesn't exist"}*/
			return $retArr;
		}
	}
}//publish_Site

//Unpublish Site (/sites/multiscreen/unpublish/{site_name})
function unpublish_Site($site_name){
	
	$curl = curl_init();
	
	curl_setopt_array($curl, array(
		CURLOPT_URL => duda_endpoint."/sites/multiscreen/unpublish/".$site_name,
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 30,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => "POST",
		CURLOPT_HTTPHEADER => array(
			"Authorization: Basic ".API_KEY."",
			"Content-Type: application/json",
			"cache-control: no-cache"
		),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//204
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 204) {
			$retArr = ["response_code"=>$responseCode];
			//{"response_code"=>204}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceNotExist","message": "Site with alias '861470fb' doesn't exist"}*/
			return $retArr;
		}
	}
}//unpublish_Site

//Delete Site (DELETE /sites/multiscreen/{site_name})
function delete_Site($site_name){
	
	$curl = curl_init();
	
	curl_setopt_array($curl, array(
		CURLOPT_URL => duda_endpoint."/sites/multiscreen/".$site_name,
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 30,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => "DELETE",
		CURLOPT_HTTPHEADER => array(
			"Authorization: Basic ".API_KEY."",
			"Content-Type: application/json",
			"cache-control: no-cache"
		),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//204
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 204) {
			$retArr = ["response_code"=>$responseCode];
			//{"response_code"=>204}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceNotExist","message": "Site with alias '861470fb' doesn't exist"}*/
			return $retArr;
		}
	}
}//unpublish_Site

//Delete Account Access /accounts/{account_name}/sites/{site_name}/permissions
function delete_Access($account_name,$site_name){

	$curl = curl_init();
		
		curl_setopt_array($curl, array(
			CURLOPT_URL => duda_endpoint."/accounts/".$account_name."/sites/".$site_name."/permissions",
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_MAXREDIRS => 10,
			CURLOPT_TIMEOUT => 30,
			CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			CURLOPT_CUSTOMREQUEST => "DELETE",
			CURLOPT_HTTPHEADER => array(
				"Authorization: Basic ".API_KEY."",
				"Content-Type: application/json",
				"cache-control: no-cache"
			),
		));
	
		//Initiate cURL
		$response = curl_exec($curl);//204
		//Check Main cURL Status
		$err = curl_error($curl);
		//Check Response Code eg: 240 / 200 / 400 etc.
		$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
		
		curl_close($curl);
		
		if($err){
			echo "cURL Error #:" . $err;
		}else{
			if ($responseCode == 204) {
				$retArr = ["response_code"=>$responseCode];
				//{"response_code"=>204}
				return $retArr;
			} else {
				$error = json_decode($response);
				$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
				/*{"error_code": "ResourceNotExist","message": "Site with alias '861470fb' doesn't exist"}*/
				return $retArr;
			}
		}
}//delete_Access

//Delete Account (DELETE /accounts/{account_name})
function delete_Account($account_name){
	
	$curl = curl_init();
	
	curl_setopt_array($curl, array(
		CURLOPT_URL => duda_endpoint."/accounts/".$account_name,
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 30,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => "DELETE",
		CURLOPT_HTTPHEADER => array(
			"Authorization: Basic ".API_KEY."",
			"Content-Type: application/json",
			"cache-control: no-cache"
		),
	));
	
	//Initiate cURL
	$response = curl_exec($curl);//204
	//Check Main cURL Status
	$err = curl_error($curl);
	//Check Response Code eg: 240 / 200 / 400 etc.
	$responseCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	
	curl_close($curl);
	
	if($err){
		echo "cURL Error #:" . $err;
	}else{
		if ($responseCode == 204) {
			$retArr = ["response_code"=>$responseCode];
			//{"response_code"=>204}
			return $retArr;
		} else {
			$error = json_decode($response);
			$retArr = ["response_code"=>$responseCode,"error_code"=>$error->error_code,"message"=>$error->message];
			/*{"error_code": "ResourceNotExist","message": "Site with alias '861470fb' doesn't exist"}*/
			return $retArr;
		}
	}
}//delete_Account
?>
