<?php 
require_once('stripe\stripe-php\init.php');

//Create Customer
function create_customer($create_account_setting){
    try{

        \Stripe\Stripe::setApiKey(SK_KEY);
        $customer = \Stripe\Customer::create($create_account_setting);
        return $customer->id;

    }catch(Exception $e){

        stripe_Error_Handler([
            'request'=>'Create Customer',
            'code'=>'CreatingCustomerFailed',
            'message'=>$e->getMessage(),
            'account_name'=>$GLOBALS['account_name'],
            'first_name'=>$GLOBALS['first_name']
        ]);
        exit;
    }
}

function create_subscription($subscription_settings){
    try{
        \Stripe\Stripe::setApiKey(SK_KEY);
        $subscription = \Stripe\Subscription::create($subscription_settings);
        return $subscription->status;//active || trialing
    } catch(Exception $e){
        stripe_Error_Handler([
            'request'=>'Create Subscription',
            'code'=>'CreatingSubscriptionFailed',
            'message'=>$e->getMessage(),
            'account_name'=>$GLOBALS['account_name'],
            'first_name'=>$GLOBALS['first_name']
        ]);
        exit;
    }
}

//Create Charge
function create_charge($customerID){
    try{
        \Stripe\Stripe::setApiKey(SK_KEY);
        // $date = date("Y-m-d", strtotime("+1 month"));
        $charge = \Stripe\Charge::create(array(
          "amount" => 100,
          "currency" => $GLOBALS['currency'] ,
          "description" => 'DIY',
          "customer" => $customerID,
          "receipt_email" => $GLOBALS['account_name']      
        ));
        return $charge->status;//succeeded
    }catch(Exception $e){
        stripe_Error_Handler([
            'request'=>'Create Charge',
            'code'=>'CreatingChargeFailed',
            'message'=>$e->getMessage(),
            'account_name'=>$GLOBALS['account_name'],
            'first_name'=>$GLOBALS['first_name']
        ]);
        exit;
    }    
    
}
?>